
const binaryEncoder = require('binary-parser-encoder').Parser;


colorParser = new binaryEncoder()
	.uint8('colorspec')			//  RGB, HSV, CMYK or HSL, invalid
	.uint16('alpha')
	.uint16('red')
	.uint16('green')
	.uint16('blue')
	.uint16('pad')
	;

function encodeColor(val, obj) {
	let color_code = val.startsWith('#') ? val.substring(1) : val;
	if (color_code.length != 6 && color_code.length != 8) {
		throw new Error(`Invalid color code ${val}. Must be #rrggbbaa or #rrggbb format`);
	}

	color_code = (color_code.length == 6) ? color_code + 'FF' : color_code;		
	const color = parseInt(color_code, 16);
	return {
		colorspec: 0x00,
		alpha: (color >> 0) & 0xFF,
		red: (color >> 24) & 0xFF,
		green: (color >> 16) & 0xFF,
		blue: (color >> 8) & 0xFF,
		pad: 0x00
	};
}

// To clear highlighting send an  invalid QColor value for  either or both of the background and foreground fields.
highlightCallsignEncoder = new binaryEncoder()
	.uint32('callsign_length', { encoder: (str, obj) => obj['callsign'].length })
	.string('callsign', { length: 'callsign_length' })
	.nest('background', { type: colorParser, encoder: encodeColor })
	.nest('foreground', { type: colorParser, encoder: encodeColor })

const o = {
	callsign: 'N1SH',
	foreground: 'FF0000',
	background: '#FFFFFF',
}

const encoded = highlightCallsignEncoder.encode(o);
console.log(encoded)